#include <stdio.h>

#define MAX 4001
#define TRUE 1
#define FALSE 0

FILE *Fin, *Fout;

long a[MAX];
unsigned char b[MAX], c[MAX], Pus[MAX];
long G[MAX][2];
unsigned char cifre[10], cifreTest[10];
long n, Nre, NrG, maxe, btest, ctest;
unsigned char OK;

int ToatePuse(void)
{
  int i, x;

  x = TRUE;
  for (i=1; i<=n; i++)
	x*=Pus[i];
  return x;
}

void Cifrele(long x, unsigned char c[10])
{
  int j;

  for (j=0; j<=9; j++) c[j]=0;
  while (x)
	{
	  c[x%10]++;
	  x/=10;
	}
}

void Citire(void)
{
  int i, j;
  long x;

  fscanf(Fin, "%ld", &n);
  for (i=1; i<=n; i++)
	{
	   fscanf(Fin, "%ld", &a[i]);
	/*construiesc 2 vectori ajutatori
  - vectorul b care va contine numarul de cifre al fiecarui element
  - vectorul c care va contine numarul de cifre distincte a fiecarui element*/
	   for (j=0; j<=9; j++) cifre[j]=0;
	   x=a[i];
	   while (x)
		 {
		   b[i]++;      //numar total de cifre
		   cifre[x%10]=1;
		   x/=10;
		 }
	   for (j=0; j<=9; j++)
		 c[i]+=cifre[j]; //numar de cifre distincte
	 }
}

void Sortare(void)
{
  int i, j;
  long min, pm, x, aux;

/*ordonez cei trei vectori crescator dupa numarul de cifre (dupa b)
si dupa numarul de cifre distincte, deci cheia de sortare va fi un numar
construit dupa formula b[i]*10+c[i] */
  for (i=1; i<=n-1; i++)
	{
	  min=b[i]*10+c[i]; pm=i;
	  for (j=i+1; j<=n; j++)
		{
		  x=b[j]*10+c[j];
		  if (x<min)
			{
			  min=x; pm=j;
			}
		}
	  aux=c[i]; c[i]=c[pm]; c[pm]=aux;
	  aux=b[i]; b[i]=b[pm]; b[pm]=aux;
	  aux=a[i]; a[i]=a[pm]; a[pm]=aux;
	}
}

void FormarePlutoane(void)
{
  int i, j;

/*formez si numar plutoanele
  - plutoanele le voi retine pe linii distincte a matricii G
  - in fiecare linie, elementul 0 va contine numarul de elemente din pluton
	iar elementul 1 reprezentantul plutonului, primul care apare in a*/
  while (!ToatePuse())
	{
	  i=1;
	  while (Pus[i]) i++;  //caut primul nepus inca
	  //retinem primul element nepus din pluton cu caracteristicile lui
	  btest=b[i]; ctest=c[i];
	  NrG=NrG+1; G[NrG][0]=1;
	  G[NrG][1]=a[i]; Pus[i]=TRUE; //il pun in pluton
	  Cifrele(a[i], cifreTest); //retin cifrele in cifreTest[]
	  //verific elementele cu aceleasi caracteristici daca fac parte din
	  //acelasi pluton cu primul element pe care l-am retinut
	  i++;
	  while ((b[i]==btest) && (c[i]==ctest) && (i<=n))
		{                  //ar putea face parte din acelasi pluton
		  Cifrele(a[i], cifre);//aflu cifrele in cifre[]
		  OK=TRUE;             //testez daca are aceleasi cifre
		  for (j=0; j<=9; j++)
			if (cifreTest[j]!=cifre[j]) OK=FALSE;
		  if (OK)              //are aceleasi cifre
			{
			  G[NrG][0]++;     //un nou soldat in pluton
			  Pus[i]=TRUE;     //l-am pus
			}
		  i++;
		}
	}
}

void Afisare(void)
{
  int i, j;
  long x;

  fprintf(Fout, "%ld\n", NrG);      //cerinta 1
  maxe=0;   //determin numarul maxim de elemente ale unui pluton
  for (i=1; i<=n; i++)
	if (G[i][0]>maxe)
	  {
		maxe=G[i][0];
		x=G[i][1];         //retin reprezentantul plutonului numeros
	  }
  fprintf(Fout, "%ld\n", maxe);       //cerinta 2
  Nre=0;
  for (i=1; i<=NrG; i++)
	if (G[i][0]==maxe)
	  Nre++;
  fprintf(Fout, "%ld\n", Nre);        //cerinta 3

  i=1;
  while (x!=a[i]) i++;         //il caut in a
  fprintf(Fout, "%ld ", a[i]); //scriu reprezentantul plutonului
  btest=b[i]; ctest=c[i];      //retin caracteristicile
  Cifrele(a[i], cifreTest);    //aflu cifrele

  i++;                         //cerinta 4
  while ((b[i]==btest) && (c[i]==ctest) && (i<=n))
	{                    //ar putea face parte din acelasi pluton
	  Cifrele(a[i], cifre);    //aflu cifrele
	  OK=TRUE;                 //testez daca are aceleasi cifre
	  for (j=0; j<=9; j++)
		if (cifreTest[j]!=cifre[j]) OK=FALSE;
	  if (OK)                  //are aceleasi cifre
		fprintf(Fout, "%ld ", a[i]); //il afisez
	  i++;
	}

  fprintf(Fout, "\n");
}

int main(void)
{
  Fin=fopen("pluton.in", "rt"); //deschid fisierul 'pluton.in' pentru citire
  Fout=fopen("pluton.out", "wt");//deschid fisierul 'pluton.out' pentru scriere
  Citire();
  Sortare();
  FormarePlutoane();
  Afisare();
  fclose(Fin);
  fclose(Fout);
  return 0;
}
